name: Unofficial Support

on:
  push:
    branches:
      - 'main'
      - '*-maintenance'
      - '*-dev'
      - '*-stable'
    tags:
      - '!*' # Do not execute on tags
  pull_request:
    branches:
      - '*'
  # Allow manually triggering the workflow.
  workflow_dispatch:

# Cancels all previous workflow runs for the same branch that have not yet completed.
concurrency:
  # The concurrency group contains the workflow name and the branch name.
  group: ${{ github.workflow }}-${{ github.ref }}
  cancel-in-progress: true

jobs:
  test:
    name: Specs - Ruby ${{ matrix.ruby }} ${{matrix.gemfile}} ${{ matrix.name_extra || '' }}
    env: # $BUNDLE_GEMFILE must be set at the job level, so it is set for all steps
      BUNDLE_GEMFILE: ${{ github.workspace }}/gemfiles/${{ matrix.gemfile }}.gemfile
    if: "!contains(github.event.commits[0].message, '[ci skip]') && !contains(github.event.commits[0].message, '[skip ci]')"
    strategy:
      fail-fast: false
      matrix:
        experimental: [false]
        gemfile:
          - f0
          - f1
          - f2
        rubygems:
          - latest
        bundler:
          - latest
        ruby:
          - "2.3"
          - "2.4"
          - "2.5"
          - "2.6"
        exclude:
          - ruby: "2.3"
            gemfile: "f1"
          - ruby: "2.3"
            gemfile: "f2"
          - ruby: "2.4"
            gemfile: "f2"
          - ruby: "2.5"
            gemfile: "f2"

    runs-on: ubuntu-20.04
    continue-on-error: ${{ matrix.experimental || endsWith(matrix.ruby, 'head') }}
    steps:
      - name: Checkout
        uses: actions/checkout@v3
      - name: Setup Ruby & Bundle
        uses: ruby/setup-ruby@v1
        with:
          ruby-version: ${{ matrix.ruby }}
          rubygems: ${{ matrix.rubygems }}
          bundler: ${{ matrix.bundler }}
          bundler-cache: true
      - name: Run tests
        run: bundle exec rake test
